import Ajv from 'ajv';
export function validateInputBySchema(input, schema) {
    const validator = new Ajv({
        strict: false,
        coerceTypes: true,
        useDefaults: true,
        removeAdditional: 'all',
    });
    const validate = validator.compile(schema);
    const data = JSON.parse(JSON.stringify(input));
    if (false === validate(data)) {
        if (validate.errors) {
            for (var error of validate.errors) {
                throw new Error(`${error.keyword} - ${error.message}`);
            }
        }
        throw new Error('Unknown error');
    }
    return data;
}
