import { XMLParser } from 'fast-xml-parser';
export function ensureSize(svg, defaultSize = 512) {
    let size = defaultSize;
    svg = svg.replace(/<svg([^>]*)/, (match, g1) => {
        const found = g1.match(/width="([^"]+)"/);
        if (found) {
            size = parseInt(found[1]);
        }
        if (g1.match(/width="([^"]+)"/)) {
            g1 = g1.replace(/width="([^"]+)"/, `width="${size}"`);
        }
        else {
            g1 += ` width="${size}"`;
        }
        if (g1.match(/height="([^"]+)"/)) {
            g1 = g1.replace(/height="([^"]+)"/, `height="${size}"`);
        }
        else {
            g1 += ` height="${size}"`;
        }
        return `<svg${g1}`;
    });
    return { svg, size };
}
export function getMetadata(svg) {
    var _a, _b;
    const parser = new XMLParser();
    const xml = parser.parse(svg);
    const rdfDescription = (_b = (_a = xml.svg.metadata) === null || _a === void 0 ? void 0 : _a['rdf:RDF']) === null || _b === void 0 ? void 0 : _b['rdf:Description'];
    return {
        title: rdfDescription === null || rdfDescription === void 0 ? void 0 : rdfDescription['dc:title'],
        source: rdfDescription === null || rdfDescription === void 0 ? void 0 : rdfDescription['dc:source'],
        creator: rdfDescription === null || rdfDescription === void 0 ? void 0 : rdfDescription['dc:creator'],
        license: rdfDescription === null || rdfDescription === void 0 ? void 0 : rdfDescription['dcterms:license'],
        copyright: rdfDescription === null || rdfDescription === void 0 ? void 0 : rdfDescription['dc:rights'],
    };
}
