/**
 * Error thrown when procps is missing on non-Windows systems
 */
export declare class ProcpsMissingError extends Error {
    readonly originalError?: Error;
    constructor(originalError?: Error);
}
/**
 * Check if the required process listing command is available
 * @throws {ProcpsMissingError} if the command is not available
 */
export declare function validateProcpsAvailable(): void;
