"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.times = times;
/**
 * Generates an array by running a function n times
 * @param n The number of times to run the function
 * @param fn The function to generate each element
 * @returns An array containing the results
 */
function times(n, f) {
    return Array.from({ length: n }, (_, i) => f(i));
}
//# sourceMappingURL=Times.js.map