"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagNames = exports.XMPTagsNames = exports.MakerNotesTagsNames = exports.JFIFTagsNames = exports.IPTCTagsNames = exports.RIFFTagsNames = exports.RAFTagsNames = exports.QuickTimeTagsNames = exports.PrintIMTagsNames = exports.PhotoshopTagsNames = exports.PanasonicRawTagsNames = exports.MetaTagsNames = exports.EXIFTagsNames = exports.MPFTagsNames = exports.JSONTagsNames = exports.FlashPixTagsNames = exports.CompositeTagsNames = exports.APPTagsNames = exports.FileTagsNames = exports.ExifToolTagsNames = void 0;
const ExifToolVendoredTags_1 = require("./ExifToolVendoredTags");
const GeolocationTags_1 = require("./GeolocationTags");
const ICCProfileTags_1 = require("./ICCProfileTags");
const ImageDataHashTag_1 = require("./ImageDataHashTag");
const IPTCApplicationRecordTags_1 = require("./IPTCApplicationRecordTags");
const MWGTags_1 = require("./MWGTags");
const StrEnum_1 = require("./StrEnum");
exports.ExifToolTagsNames = (0, StrEnum_1.strEnum)("Error", "ExifToolVersion", "SourceFile", "Warning");
exports.FileTagsNames = (0, StrEnum_1.strEnum)("BitsPerSample", "BMPVersion", "ColorComponents", "CurrentIPTCDigest", "Directory", "EncodingProcess", "ExifByteOrder", "FileAccessDate", "FileCreateDate", "FileInodeChangeDate", "FileModifyDate", "FileName", "FilePermissions", "FileSize", "FileType", "FileTypeExtension", "ImageDataMD5", "ImageHeight", "ImageWidth", "MIMEType", "NumColors", "NumImportantColors", "PixelsPerMeterX", "PixelsPerMeterY", "Planes", "YCbCrSubSampling");
exports.APPTagsNames = (0, StrEnum_1.strEnum)("AboveColor", "Again", "AtmosphericTemperature", "AutoISOMax", "AutoISOMin", "AutoRotation", "B5100", "BelowColor", "Bgain", "BHighLight", "BHL", "Blk0", "Blk1", "BMean", "Boff", "BSd", "BSD", "BStrobe", "CameraModel", "CameraPartNumber", "CameraSerialNumber", "CameraSoftware", "Case", "CBal", "Color", "COLOR1", "COLOR2", "COLOR3", "COLOR4", "ColorTransform", "Compass", "ContTake", "CreatorSoftware", "DateTimeGenerated", "DCTEncodeVersion", "DeviceName", "DiagonalFieldOfView", "DigitalZoomOn", "EmbeddedImage", "EmbeddedImageHeight", "EmbeddedImageType", "EmbeddedImageWidth", "Emissivity", "EXP1", "EXP2", "EXP3", "ExposRatio", "Exposure", "ExposureType", "FieldOfView", "FilterModel", "FilterPartNumber", "FilterSerialNumber", "FinalRatio", "FlashTime", "FMean", "Fnumber", "FocusDistance", "FocusPos", "FocusStepCount", "FrameRate", "Gain", "GBgain", "GBoff", "GHighLight", "GHL", "GMean", "GPSTrack", "GPSTrackRef", "GPSValid", "GRgain", "GRoff", "GSd", "GSD", "HDRGainCurve", "HDRGainCurveSize", "ID", "IRWindowTemperature", "IRWindowTransmission", "Isotherm1Color", "Isotherm2Color", "JPEG1", "LensPartNumber", "LensProjection", "LightS", "Mean", "Meas1Label", "Meas1Params", "Meas1Type", "Meas2Label", "Meas2Params", "Meas2Type", "MediaUniqueID", "MetadataVersion", "MotorPos", "Offset", "OffsetX", "OffsetY", "OverflowColor", "Palette", "PaletteColors", "PaletteFileName", "PaletteMethod", "PaletteName", "PaletteStretch", "Param0", "PhotoResolution", "PicLen", "Protect", "Protune", "R5100", "Rate", "RawThermalImage", "RawThermalImageHeight", "RawThermalImageType", "RawThermalImageWidth", "RawValueMedian", "RawValueRange", "RawValueRangeMax", "RawValueRangeMin", "Real2IR", "ReflectedApparentTemperature", "RelativeHumidity", "Resolution", "REV", "Rgain", "RHighLight", "RHL", "RMean", "Roff", "RSd", "RSD", "RStrobe", "S0", "SpotMeter", "StrobeTime", "T0", "TagB", "TagQ", "TagR", "TagS", "ThmLen", "UnderflowColor", "Version", "YLevel", "YTarget", "Zoom", "ZoomPos");
exports.CompositeTagsNames = (0, StrEnum_1.strEnum)("AdvancedSceneMode", "Aperture", "AutoFocus", "AvgBitrate", "BlueBalance", "CFAPattern", "CircleOfConfusion", "ConditionalFEC", "ContrastDetectAF", "DigitalCreationDateTime", "DOF", "DriveMode", "ExtenderStatus", "FlashType", "FocalLength35efl", "FOV", "GPSDateTime", "GPSPosition", "HyperfocalDistance", "ImageSize", "Lens", "Lens35efl", "LensID", "LightValue", "Megapixels", "OriginalDecisionData", "PeakSpectralSensitivity", "PhaseDetectAF", "PreviewImage", "RedBalance", "RedEyeReduction", "RicohPitch", "RicohRoll", "Rotation", "RunTimeSincePowerUp", "ScaleFactor35efl", "ShootingMode", "ShutterCurtainHack", "ShutterSpeed", "SubSecCreateDate", "SubSecDateTimeOriginal", "SubSecMediaCreateDate", "SubSecModifyDate");
exports.FlashPixTagsNames = (0, StrEnum_1.strEnum)("AudioStream", "CodePage", "CreatingApplication", "ExtensionClassID", "ExtensionCreateDate", "ExtensionDescription", "ExtensionModifyDate", "ExtensionName", "ExtensionPersistence", "ScreenNail", "UsedExtensionNumbers");
exports.JSONTagsNames = (0, StrEnum_1.strEnum)("AIScene", "FilterId", "Hdr", "Mirror", "OpMode", "ZoomMultiple");
exports.MPFTagsNames = (0, StrEnum_1.strEnum)("DependentImage1EntryNumber", "DependentImage2EntryNumber", "ImageUIDList", "MPFVersion", "MPImageFlags", "MPImageFormat", "MPImageLength", "MPImageStart", "MPImageType", "NumberOfImages", "TotalFrames");
exports.EXIFTagsNames = (0, StrEnum_1.strEnum)("Acceleration", "AntiAliasStrength", "ApertureValue", "Artist", "AsShotNeutral", "BaselineExposure", "BlackLevel", "BlackLevelBlue", "BlackLevelGreen", "BlackLevelRed", "BlackLevelRepeatDim", "BrightnessValue", "CameraElevationAngle", "CFAPlaneColor", "CFARepeatPatternDim", "ChromaticAberrationCorrection", "ColorSpace", "CompositeImage", "CompressedBitsPerPixel", "Contrast", "Copyright", "CreateDate", "CustomRendered", "DateTimeOriginal", "DefaultCropOrigin", "DefaultCropSize", "DeviceSettingDescription", "DigitalZoomRatio", "DNGBackwardVersion", "DNGVersion", "DocumentName", "ExifImageHeight", "ExifImageWidth", "ExposureIndex", "ExposureMode", "ExposureProgram", "ExposureTime", "FileSource", "Flash", "FlashEnergy", "FNumber", "FocalLength", "FocalLengthIn35mmFormat", "FocalPlaneResolutionUnit", "FocalPlaneXResolution", "FocalPlaneYResolution", "GainControl", "Gamma", "GPSAltitude", "GPSAltitudeRef", "GPSAreaInformation", "GPSDateStamp", "GPSDestBearing", "GPSDestBearingRef", "GPSDestDistance", "GPSDestDistanceRef", "GPSDestLatitude", "GPSDestLatitudeRef", "GPSDestLongitude", "GPSDestLongitudeRef", "GPSDifferential", "GPSDOP", "GPSHPositioningError", "GPSImgDirection", "GPSImgDirectionRef", "GPSLatitude", "GPSLatitudeRef", "GPSLongitude", "GPSLongitudeRef", "GPSMapDatum", "GPSMeasureMode", "GPSProcessingMethod", "GPSSatellites", "GPSSpeed", "GPSSpeedRef", "GPSStatus", "GPSTimeStamp", "GPSVersionID", "HighISOMultiplierBlue", "HighISOMultiplierGreen", "HighISOMultiplierRed", "HostComputer", "ImageDescription", "ImageTitle", "InteropIndex", "InteropVersion", "ISO", "ISOSpeed", "JpgFromRaw", "JpgFromRawLength", "JpgFromRawStart", "LensInfo", "LensMake", "LensModel", "LensSerialNumber", "LightSource", "LinearityLimitBlue", "LinearityLimitGreen", "LinearityLimitRed", "Make", "MakerNoteSamsung1a", "MakerNoteUnknownBinary", "MakerNoteUnknownText", "MaxApertureValue", "MeteringMode", "Model", "Model2", "ModifyDate", "Noise", "NoiseProfile", "NoiseReductionParams", "OffsetSchema", "OffsetTime", "OffsetTimeDigitized", "OffsetTimeOriginal", "Orientation", "OtherImage", "OtherImageLength", "OtherImageStart", "Padding", "PageName", "PanasonicRawVersion", "Photographer", "PhotometricInterpretation", "PlanarConfiguration", "Pressure", "PreviewDateTime", "PreviewTIFF", "PrimaryChromaticities", "ProcessingSoftware", "RawDataOffset", "RawDataUniqueID", "RawFormat", "RawImageSegmentation", "RecommendedExposureIndex", "ReferenceBlackWhite", "RelatedImageFileFormat", "RelatedImageHeight", "RelatedImageWidth", "RelatedSoundFile", "ResolutionUnit", "RowsPerStrip", "SamplesPerPixel", "Saturation", "SceneCaptureType", "SceneType", "SensingMethod", "SensitivityType", "Sharpness", "ShutterSpeedValue", "Software", "SonyRawFileType", "SonyToneCurve", "SpatialFrequencyResponse", "SRawType", "StandardOutputSensitivity", "StripByteCounts", "StripOffsets", "SubfileType", "SubjectArea", "SubjectDistance", "SubjectDistanceRange", "SubjectLocation", "SubSecTime", "SubSecTimeDigitized", "SubSecTimeOriginal", "ThumbnailImage", "ThumbnailLength", "ThumbnailOffset", "ThumbnailTIFF", "TileByteCounts", "TileLength", "TileOffsets", "TileWidth", "TimeZoneOffset", "TransferFunction", "UniqueCameraModel", "UserComment", "WaterDepth", "WhiteBalance", "WhiteLevel", "WhitePoint", "XiaomiModel", "XPAuthor", "XPComment", "XPKeywords", "XPSubject", "XPTitle", "XResolution", "YCbCrCoefficients", "YCbCrPositioning", "YResolution");
exports.MetaTagsNames = (0, StrEnum_1.strEnum)("BorderID", "BorderLocation", "BorderName", "BordersVersion", "BorderType", "CameraOwner", "CaptureConditionsPAR", "DigitalEffectsName", "DigitalEffectsType", "DigitalEffectsVersion", "EditTagArray", "FilmGencode", "FilmProductCode", "FilmSize", "ImageSourceEK", "MetadataNumber", "ModelAndVersion", "WatermarkType");
exports.PanasonicRawTagsNames = (0, StrEnum_1.strEnum)("DistortionScale", "NumWBEntries");
exports.PhotoshopTagsNames = (0, StrEnum_1.strEnum)("CopyrightFlag", "DisplayedUnitsX", "DisplayedUnitsY", "GlobalAltitude", "GlobalAngle", "HasRealMergedData", "IPTCDigest", "NumSlices", "PhotoshopFormat", "PhotoshopQuality", "PhotoshopThumbnail", "PrintPosition", "PrintScale", "PrintStyle", "ReaderName", "SlicesGroupName", "WriterName");
exports.PrintIMTagsNames = (0, StrEnum_1.strEnum)("PrintIMVersion");
exports.QuickTimeTagsNames = (0, StrEnum_1.strEnum)("AndroidCaptureFPS", "AndroidVersion", "AndroidVideoTemporalLayersCount", "AudioBitsPerSample", "AudioChannels", "AudioFormat", "AudioSampleRate", "AudioVendorID", "Author", "BackgroundColor", "Balance", "BitDepth", "ChapterListTrackID", "CleanApertureDimensions", "ColorPrimaries", "ColorProfiles", "CompatibleBrands", "CompressorID", "CompressorName", "ContentDescribes", "CreationDate", "CurrentTime", "Duration", "EncodedPixelsDimensions", "FontName", "GenBalance", "GenFlags", "GenGraphicsMode", "GenMediaVersion", "GenOpColor", "GPSCoordinates", "GraphicsMode", "HandlerClass", "HandlerDescription", "HandlerType", "HandlerVendorID", "LocationAccuracyHorizontal", "MajorBrand", "MatrixCoefficients", "MatrixStructure", "MediaCreateDate", "MediaDataOffset", "MediaDataSize", "MediaDuration", "MediaHeaderVersion", "MediaLanguageCode", "MediaModifyDate", "MediaTimeScale", "MediaUID", "MetaFormat", "MinorVersion", "MovieHeaderVersion", "NextTrackID", "OpColor", "OtherFormat", "PlaybackFrameRate", "PlayMode", "PosterTime", "PreferredRate", "PreferredVolume", "PreviewDuration", "PreviewTime", "ProductionApertureDimensions", "PurchaseFileFormat", "SelectionDuration", "SelectionTime", "SerialNumberHash", "SourceImageHeight", "SourceImageWidth", "TextColor", "TextFace", "TextFont", "TextSize", "TimecodeTrack", "TimeScale", "TrackCreateDate", "TrackDuration", "TrackHeaderVersion", "TrackID", "TrackLayer", "TrackModifyDate", "TrackVolume", "TransferCharacteristics", "VendorID", "VideoFrameRate", "VideoFullRangeFlag");
exports.RAFTagsNames = (0, StrEnum_1.strEnum)("ChromaticAberrationParams", "FujiLayout", "GeometricDistortionParams", "RAFCompression", "RawExposureBias", "RawImageCroppedSize", "RawImageCropTopLeft", "RawImageFullHeight", "RawImageFullSize", "RawImageFullWidth", "VignettingParams", "XTransLayout");
exports.RIFFTagsNames = (0, StrEnum_1.strEnum)("AudioCodec", "AudioSampleCount", "AvgBytesPerSec", "Encoding", "FrameCount", "MaxDataRate", "NumChannels", "SampleRate", "SampleSize", "StreamCount", "VideoCodec", "VideoFrameCount");
exports.IPTCTagsNames = (0, StrEnum_1.strEnum)("ApplicationRecordVersion", "Caption-Abstract", "Category", "City", "CodedCharacterSet", "Contact", "CopyrightNotice", "Credit", "DateSent", "DateTimeCreated", "Destination", "DigitalCreationDate", "DigitalCreationTime", "EnvelopeNumber", "EnvelopePriority", "EnvelopeRecordVersion", "FileVersion", "Headline", "Keywords", "ObjectName", "OriginalTransmissionReference", "OriginatingProgram", "Prefs", "ProgramVersion", "ServiceIdentifier", "Source", "SpecialInstructions", "SupplementalCategories", "TimeCreated", "TimeSent", "Urgency");
exports.JFIFTagsNames = (0, StrEnum_1.strEnum)("JFIFVersion");
exports.MakerNotesTagsNames = (0, StrEnum_1.strEnum)("AccelerationTracking", "AccelerationVector", "Accelerometer", "AccelerometerX", "AccelerometerY", "AccelerometerZ", "AccessorySerialNumber", "AccessoryType", "ActualCompensation", "AddAspectRatioInfo", "AddIPTCInformation", "AddOriginalDecisionData", "ADJDebugInfo", "AdjustmentMode", "ADLBracketingStep", "ADLBracketingType", "AdvancedFilter", "AdvancedSceneType", "AEAperture", "AEApertureSteps", "AEAverage", "AEBAutoCancel", "AEBBracketValue", "AEBracketingSteps", "AEBSequence", "AEBSequenceAutoCancel", "AEBShotCount", "AEBXv", "AEDebugInfo", "AEExposureTime", "AEHistogramInfo", "AELButton", "AELExposureIndicator", "AELiveViewHistogramInfo", "AELiveViewLocalHistogram", "AELocalHistogram", "AELock", "AELockButton", "AELockButtonPlusDials", "AELockMeterModeAfterFocus", "AEMaxAperture", "AEMeteringMode", "AEMeteringSegments", "AEMicroadjustment", "AEMinAperture", "AEMinExposureTime", "AEProgramMode", "AESetting", "AEStable", "AETarget", "AEWhiteBalance", "AEXv", "AFAccelDecelTracking", "AFActivation", "AFAdjustment", "AFAndMeteringButtons", "AFAperture", "AFAreaHeight", "AFAreaHeights", "AFAreaIllumination", "AFAreaMode", "AFAreaModeSetting", "AFAreaPointSize", "AFAreas", "AFAreaSelectionMethod", "AFAreaSelectMethod", "AFAreaSize", "AFAreaWidth", "AFAreaWidths", "AFAreaXPosition", "AFAreaYPosition", "AFAreaZoneSize", "AFAssist", "AFAssistBeam", "AFAssistLamp", "AFButtonPressed", "AFConfidence", "AFConfigTool", "AFCoordinatesAvailable", "AFDebugInfo", "AFDefocus", "AFDetectionMethod", "AFDuringLiveView", "AFFineTune", "AFFineTuneAdj", "AFFineTuneAdjTele", "AFFineTuneIndex", "AFIlluminator", "AFInfo2Version", "AFIntegrationTime", "AFMeasuredDepth", "AFMicroAdj", "AFMicroAdjMode", "AFMicroAdjRegisteredLenses", "AFMicroadjustment", "AFMicroAdjValue", "AFMode", "AFModeRestrictions", "AFOnAELockButtonSwitch", "AFOnButton", "AFPerformance", "AFPoint", "AFPointActivationArea", "AFPointAreaExpansion", "AFPointAtShutterRelease", "AFPointAutoSelection", "AFPointBrightness", "AFPointDetails", "AFPointDisplayDuringFocus", "AFPointIllumination", "AFPointInFocus", "AFPointMode", "AFPointPosition", "AFPointRegistration", "AFPoints", "AFPointSel", "AFPointSelected", "AFPointSelection", "AFPointSelectionMethod", "AFPointSetting", "AFPointsInFocus", "AFPointsInFocus1D", "AFPointsInFocus5D", "AFPointSpotMetering", "AFPointsSelected", "AFPointsSpecial", "AFPointsUsed", "AFPointSwitching", "AFPredictor", "AFTracking", "AFTrackingSensitivity", "AFType", "AFWithShutter", "AIServoContinuousShooting", "AIServoFirstImage", "AIServoFirstImagePriority", "AIServoImagePriority", "AIServoSecondImage", "AIServoSecondImagePriority", "AIServoTrackingMethod", "AIServoTrackingSensitivity", "AISubjectTrackingMode", "Altitude", "AmbienceSelection", "AmbientTemperature", "AmbientTemperatureFahrenheit", "AntiFlicker", "ApertureLock", "ApertureRange", "ApertureRingUse", "ApertureSetting", "ApplySettingsToLiveView", "ApplyShootingMeteringMode", "ApproximateFNumber", "ArtFilter", "ArtFilterEffect", "ArtMode", "ArtModeParameters", "AspectFrame", "AspectRatio", "AssignBktButton", "AssignFuncButton", "AssignMovieFunc1ButtonPlusDials", "AssignMovieFunc2Button", "AssignMoviePreviewButtonPlusDials", "AssignMovieRecordButton", "AssignMovieRecordButtonPlusDials", "AssignMovieSubselector", "AssignMovieSubselectorPlusDials", "AssignRemoteFnButton", "AssistButtonFunction", "Audio", "AudioCompression", "AutoAFPointColorTracking", "AutoAFPointSelEOSiTRAF", "AutoAperture", "AutoBracket", "AutoBracketing", "AutoBracketingMode", "AutoBracketingSet", "AutoBracketModeM", "AutoBracketOrder", "AutoBracketSet", "AutoDistortionControl", "AutoDynamicRange", "AutoExposureBracketing", "AutoFlashISOSensitivity", "AutoFP", "AutoISO", "AutoISOMinShutterSpeed", "AutoLightingOptimizer", "AutoPortraitFramed", "AutoRotate", "AuxiliaryLens", "AvApertureSetting", "AverageBlackLevel", "AverageLV", "AvSettingWithoutLens", "BabyAge", "BabyName", "Barcode", "BarometerInfoVersion", "BaseExposureCompensation", "BaseISO", "BatteryLevel", "BatteryOrder", "BatteryState", "BatteryTemperature", "BatteryType", "BatteryVoltage", "BayerPattern", "Beep", "BeepPitch", "BeepVolume", "BestShotMode", "BlackLevels", "BlackMaskBottomBorder", "BlackMaskLeftBorder", "BlackMaskRightBorder", "BlackMaskTopBorder", "BlackPoint", "BleachBypassToning", "BlueGain", "BlurControl", "BlurWarning", "BoardTemperature", "BodyBatteryADLoad", "BodyBatteryADNoLoad", "BodyBatteryState", "BodyFirmware", "BodyFirmwareVersion", "BodySerialNumber", "BracketIncrement", "BracketMode", "BracketProgram", "BracketSequence", "BracketSet", "BracketSettings", "BracketShotNumber", "BracketStep", "BracketValue", "Brightness", "BuildNumber", "BulbDuration", "BurstGroupID", "BurstMode", "BurstShot", "BurstSpeed", "BurstUUID", "ButtonFunctionControlOff", "BWFilter", "BWMode", "CAFGridSize", "CAFPointsInFocus", "CAFPointsSelected", "Calibration", "CameraDateTime", "CameraID", "CameraISO", "CameraOrientation", "CameraParameters", "CameraPictureStyle", "CameraPitch", "CameraRoll", "CameraSettingsVersion", "CameraType", "CameraYaw", "CanonExposureMode", "CanonFileDescription", "CanonFileLength", "CanonFirmwareVersion", "CanonFlashMode", "CanonImageSize", "CanonImageType", "CanonModelID", "CardShutterLock", "Categories", "CCDBoardVersion", "CCDScanMode", "CCDSensitivity", "CCDVersion", "CenterAFArea", "CenterFocusPoint", "CenterWeightedAreaSize", "CHModeShootingSpeed", "ChromaticAberrationCorr", "ChromaticAberrationCorrParams", "ChromaticAberrationSetting", "ChrominanceNoiseReduction", "Clarity", "ClarityControl", "ClearRetouch", "CLModeShootingSpeed", "CmdDialsApertureSetting", "CmdDialsChangeMainSub", "CmdDialsMenuAndPlayback", "CmdDialsReverseRotation", "CmdDialsReverseRotExposureComp", "ColorAdjustment", "ColorAdjustmentMode", "ColorBalanceBlue", "ColorBalanceGreen", "ColorBalanceRed", "ColorBalanceVersion", "ColorBitDepth", "ColorBW", "ColorChromeEffect", "ColorChromeFXBlue", "ColorCompensationFilter", "ColorCompensationFilterCustom", "ColorCompensationFilterSet", "ColorControl", "ColorCreatorEffect", "ColorDataVersion", "ColorEffect", "ColorFilter", "ColorGain", "ColorHue", "ColorMatrix", "ColorMatrixA", "ColorMatrixB", "ColorMatrixNumber", "ColorMode", "ColorProfileSettings", "ColorTempAsShot", "ColorTempAuto", "ColorTempCloudy", "ColorTempCustom", "ColorTempDaylight", "ColorTemperature", "ColorTemperatureAuto", "ColorTemperatureCustom", "ColorTemperatureSet", "ColorTemperatureSetting", "ColorTempFlash", "ColorTempFluorescent", "ColorTempKelvin", "ColorTempMeasured", "ColorTempShade", "ColorTempTungsten", "ColorTint", "ColorTone", "ColorToneAuto", "ColorToneLandscape", "ColorToneNeutral", "ColorTonePortrait", "ColorToneStandard", "CommandDials", "CommandDialsApertureSetting", "CommandDialsChangeMainSub", "CommandDialsMenuAndPlayback", "CommandDialsReverseRotation", "CommanderChannel", "CommanderGroupAManualOutput", "CommanderGroupAMode", "CommanderGroupBManualOutput", "CommanderGroupBMode", "CommanderInternalFlash", "CommanderInternalManualOutput", "CommanderInternalTTLComp", "CommanderInternalTTLCompBuiltin", "CommanderInternalTTLCompGroupA", "CommanderInternalTTLCompGroupB", "ComponentBitDepth", "ComponentVersion", "CompositionAdjust", "CompositionAdjustRotation", "CompositionAdjustX", "CompositionAdjustY", "CompressedImageSize", "CompressionFactor", "CompressionRatio", "ContentIdentifier", "ContinuousBracketing", "ContinuousDrive", "ContinuousModeDisplay", "ContinuousModeLiveView", "ContinuousShootingSpeed", "ContinuousShotLimit", "ContrastAuto", "ContrastCurve", "ContrastDetectAFArea", "ContrastDetectAFInFocus", "ContrastFaithful", "ContrastHighlight", "ContrastHighlightShadowAdj", "ContrastLandscape", "ContrastMode", "ContrastNeutral", "ContrastPortrait", "ContrastSetting", "ContrastShadow", "ContrastStandard", "ControlDialSet", "ControllerBoardVersion", "ControlMode", "ControlRingResponse", "ControlRingRotation", "ConversionLens", "Converter", "CoringFilter", "CorrelatedColorTemp", "CPUFirmwareVersion", "CPUVersions", "CreativeStyle", "CreativeStyleSetting", "CropBottomMargin", "CropHeight", "CropHiSpeed", "CropLeftMargin", "CropMode", "CroppedImageHeight", "CroppedImageLeft", "CroppedImageTop", "CroppedImageWidth", "CropRightMargin", "CropTopMargin", "CropWidth", "CrossProcess", "CustomControls", "CustomizeDials", "CustomPictureStyleFileName", "CustomSaturation", "CustomSettingsAllDefault", "CustomSettingsBank", "CustomWBBlueLevel", "CustomWBError", "CustomWBGreenLevel", "CustomWBRedLevel", "CustomWBSetting", "DarkFocusEnvironment", "DataDump", "DataScaling", "Date", "DateDisplayFormat", "DateImprint", "DateStampMode", "DateTimeStamp", "DateTimeUTC", "DaylightSavings", "DECPosition", "DefaultEraseOption", "DeletedImageCount", "DestinationCity", "DestinationCityCode", "DestinationDST", "DeviceType", "DialDirectionTvAv", "DiffractionCompensation", "DiffractionCorrection", "DigitalFilter", "DigitalGain", "DigitalICE", "DigitalZoom", "DirectoryIndex", "DirectoryNumber", "DispButton", "DisplayAllAFPoints", "DisplayAperture", "DistortionControl", "DistortionCorrection", "DistortionCorrectionSetting", "DistortionCorrectionValue", "DistortionCorrParams", "DistortionCorrParamsNumber", "DistortionCorrParamsPresent", "DriveModeSetting", "DriveSpeed", "DSPFirmwareVersion", "DustRemovalData", "DXCropAlert", "DynamicAFArea", "DynamicAreaAFAssist", "DynamicAreaAFDisplay", "DynamicRange", "DynamicRangeBoost", "DynamicRangeExpansion", "DynamicRangeOptimizer", "DynamicRangeOptimizerBracket", "DynamicRangeOptimizerLevel", "DynamicRangeOptimizerMode", "DynamicRangeOptimizerSetting", "DynamicRangeSetting", "EasyExposureComp", "EasyExposureCompensation", "EasyMode", "EffectiveLV", "EffectiveMaxAperture", "ElectronicFrontCurtainShutter", "EnergySavingMode", "Enhancement", "Enhancer", "EpsonImageHeight", "EpsonImageWidth", "EpsonSoftware", "EquipmentVersion", "ETTLII", "EventNumber", "EVSteps", "EVStepSize", "ExitPupilPosition", "ExposureBracketingIndicatorLast", "ExposureBracketShotNumber", "ExposureBracketStepSize", "ExposureBracketValue", "ExposureCompAutoCancel", "ExposureCompensationMode", "ExposureCompensationSet", "ExposureCompensationSetting", "ExposureCompStepSize", "ExposureControlStep", "ExposureControlStepSize", "ExposureCount", "ExposureDelayMode", "ExposureDifference", "ExposureIndicator", "ExposureLevelIncrements", "ExposureModeInManual", "ExposureShift", "ExposureStandardAdjustment", "ExposureTuning", "ExposureWarning", "EXRAuto", "EXRMode", "ExtendedMenuBanks", "ExtendedShutterSpeeds", "ExtendedWBDetect", "Extender", "ExtenderFirmwareVersion", "ExtenderSerialNumber", "ExternalFlash", "ExternalFlashBounce", "ExternalFlashCompensation", "ExternalFlashExposureComp", "ExternalFlashFirmware", "ExternalFlashFlags", "ExternalFlashGuideNumber", "ExternalFlashGValue", "ExternalFlashMode", "ExternalFlashReadyState", "ExternalFlashStatus", "ExternalFlashZoom", "ExternalFlashZoomOverride", "ExternalSensorBrightnessValue", "ExtraInfoVersion", "EyeDetection", "EyeStartAF", "FaceDetect", "FaceDetectArea", "FaceDetectFrameCrop", "FaceDetectFrameSize", "FaceDetection", "FaceElementPositions", "FaceElementSelected", "FaceElementTypes", "FaceInfoLength", "FaceInfoOffset", "FaceName", "FacePosition", "FacePositions", "FacesDetected", "FacesRecognized", "FaceWidth", "Fade", "FEMicroadjustment", "FileFormat", "FileIndex", "FileInfoVersion", "FileNumber", "FileNumberMemory", "FileNumberSequence", "FillFlashAutoReduction", "FilmGrainEffect", "FilmMode", "FilmType", "FilterEffect", "FilterEffectAuto", "FinderDisplayDuringExposure", "FineSharpness", "FineTuneOptCenterWeighted", "FineTuneOptHighlightWeighted", "FineTuneOptMatrixMetering", "FineTuneOptSpotMetering", "FirmwareDate", "FirmwareName", "FirmwareRevision", "FirmwareVersion", "FisheyeFilter", "FlashAction", "FlashActionExternal", "FlashActivity", "FlashBatteryLevel", "FlashBias", "FlashBits", "FlashButtonFunction", "FlashChargeLevel", "FlashColorFilter", "FlashCommanderMode", "FlashControl", "FlashControlMode", "FlashCurtain", "FlashDefault", "FlashDevice", "FlashDistance", "FlashExposureBracketValue", "FlashExposureComp", "FlashExposureCompArea", "FlashExposureCompSet", "FlashExposureIndicator", "FlashExposureIndicatorLast", "FlashExposureIndicatorNext", "FlashExposureLock", "FlashFired", "FlashFiring", "FlashFirmwareVersion", "FlashFocalLength", "FlashFunction", "FlashGNDistance", "FlashGroupACompensation", "FlashGroupAControlMode", "FlashGroupBCompensation", "FlashGroupBControlMode", "FlashGroupCCompensation", "FlashGroupCControlMode", "FlashGuideNumber", "FlashIlluminationPattern", "FlashInfoVersion", "FlashIntensity", "FlashLevel", "FlashMasterControlMode", "FlashMetering", "FlashMeteringMode", "FlashMeteringSegments", "FlashMode", "FlashModel", "FlashOptions", "FlashOutput", "FlashRemoteControl", "FlashSerialNumber", "FlashSetting", "FlashShutterSpeed", "FlashSource", "FlashStatus", "FlashStatusExternal", "FlashSyncMode", "FlashSyncSpeed", "FlashSyncSpeedAv", "FlashThreshold", "FlashWarning", "FlexibleSpotPosition", "FlickAdvanceDirection", "FlickerReduce", "FlickerReduction", "FlickerReductionIndicator", "FlickerReductionShooting", "FlightDegree", "FlightSpeed", "FocalLengthTeleZoom", "FocalPlaneAFPointArea", "FocalPlaneAFPointsUsed", "FocalPlaneDiagonal", "FocalPlaneXSize", "FocalPlaneYSize", "FocalType", "FocalUnits", "FocusArea", "FocusAreaSelection", "FocusBracket", "FocusBracketStepSize", "FocusContinuous", "FocusDisplayAIServoAndMF", "FocusDistanceRange", "FocusFrameSize", "FocusHoldButton", "FocusInfoVersion", "FocusingScreen", "FocusLocation", "FocusLocked", "FocusMode", "FocusModeSetting", "FocusModeSwitch", "FocusPeakingHighlightColor", "FocusPeakingLevel", "FocusPixel", "FocusPointPersistence", "FocusPointSchema", "FocusPointSelectionSpeed", "FocusPointWrap", "FocusPosition", "FocusPositionHorizontal", "FocusPositionVertical", "FocusProcess", "FocusRange", "FocusRangeIndex", "FocusResult", "FocusRingRotation", "FocusSetting", "FocusShiftExposureLock", "FocusShiftInterval", "FocusShiftNumberShots", "FocusShiftShooting", "FocusShiftStepWidth", "FocusStatus", "FocusStepInfinity", "FocusStepNear", "FocusTrackingLockOn", "FocusWarning", "FolderName", "FolderNumber", "FrameNumber", "FramingGridDisplay", "FreeBytes", "FreeMemoryCardImages", "FujiFlashMode", "FujiModel", "FullImageSize", "FullPressSnap", "Func1Button", "Func1ButtonPlusDials", "Func2Button", "Func3Button", "FuncButton", "FuncButtonPlusDials", "FunctionButton", "GainBase", "GEImageSize", "GEMake", "GEModel", "GimbalDegree", "Gradation", "GrainEffectRoughness", "GrainEffectSize", "GrainyBWFilter", "GreenGain", "GridDisplay", "GripBatteryADLoad", "GripBatteryADNoLoad", "GripBatteryState", "GroupAreaAFIllumination", "HDMIBitDepth", "HDMIExternalRecorder", "HDMIOutputRange", "HDMIOutputResolution", "HDR", "HDREffect", "HDRGain", "HDRHeadroom", "HDRImageType", "HDRInfoVersion", "HDRLevel", "HDRSetting", "HDRSmoothing", "HiddenDataLength", "HiddenDataOffset", "HighFrameRate", "HighISONoiseReduction", "Highlight", "Highlights", "HighlightShadow", "HighlightTone", "HighlightTonePriority", "HighlightWarning", "HighLowKeyAdj", "HighSpeedSync", "Histogram", "HometownCity", "HometownCityCode", "HometownDST", "HostSoftwareExportVersion", "HostSoftwareRendering", "Hue", "HueAdjust", "HueAdjustment", "HyperlapsDebugInfo", "Illumination", "ImageAdjustment", "ImageArea", "ImageAuthentication", "ImageBoundary", "ImageCaptureType", "ImageCount", "ImageDataSize", "ImageEditCount", "ImageEditing", "ImageEffects", "ImageGeneration", "ImageIDNumber", "ImageOptimization", "ImageProcessing", "ImageProcessingVersion", "ImageQuality", "ImageReview", "ImageReviewMonitorOffTime", "ImageReviewTime", "ImageRotated", "ImageSizeRAW", "ImageStabilization", "ImageStabilizationSetting", "ImageStyle", "ImageTemperatureMax", "ImageTemperatureMin", "ImageTone", "ImageUniqueID", "InfoButtonWhenShooting", "InfraredIlluminator", "InitialAFPointAIServoAF", "InitialAFPointInServo", "InitialZoomLiveView", "InitialZoomSetting", "InstantPlaybackSetup", "InstantPlaybackTime", "IntelligentAuto", "IntelligentContrast", "IntelligentExposure", "IntelligentResolution", "InternalFlash", "InternalFlashMode", "InternalFlashStrength", "InternalFlashTable", "InternalNDFilter", "InternalSerialNumber", "IntervalDurationHours", "IntervalDurationMinutes", "IntervalDurationSeconds", "IntervalExposureSmoothing", "IntervalLength", "IntervalMode", "IntervalNumber", "IntervalPriority", "Intervals", "IntervalShooting", "ISO2", "ISOAuto", "ISOAutoFlashLimit", "ISOAutoHiLimit", "ISOAutoMax", "ISOAutoMin", "ISOAutoMinSpeed", "ISOAutoShutterTime", "ISODisplay", "ISOExpansion", "ISOFloor", "ISOSelected", "ISOSelection", "ISOSensitivityStep", "ISOSetting", "ISOSpeedExpansion", "ISOSpeedIncrements", "ISOSpeedRange", "ISOStepSize", "ISOValue", "JPEGQuality", "JPGCompression", "JpgRecordedPixels", "KeepExposure", "KeystoneCompensation", "KeystoneDirection", "KeystoneValue", "KodakImageHeight", "KodakImageWidth", "KodakInfoType", "KodakMake", "KodakMaker", "KodakModel", "KodakVersion", "Language", "LastFileNumber", "LateralChromaticAberration", "LCDDisplayAtPowerOn", "LCDDisplayReturnToShoot", "LCDIllumination", "LCDIlluminationDuringBulb", "LCDPanels", "LensApertureRange", "LensControlRing", "LensDataVersion", "LensDistortionParams", "LensDriveNoAF", "LensDriveWhenAFImpossible", "LensFirmware", "LensFirmwareVersion", "LensFocalLength", "LensFocalRange", "LensFocusFunctionButtons", "LensFormat", "LensFStops", "LensFunc1Button", "LensFunc2Button", "LensIDNumber", "LensMaxApertureRange", "LensModulationOptimizer", "LensMount", "LensMountType", "LensPositionAbsolute", "LensProperties", "LensShading", "LensShutterLock", "LensSpec", "LensSpecFeatures", "LensTemperature", "LensType", "LensType2", "LensType3", "LensTypeMake", "LensTypeModel", "LensZoomPosition", "LevelIndicator", "LevelOrientation", "LightCondition", "LightingMode", "LightSourceSpecial", "LightSwitch", "LightValueCenter", "LightValuePeriphery", "LimitAFAreaModeSelection", "LinearityUpperMargin", "LinkAEToAFPoint", "LivePhotoVideoIndex", "LiveView", "LiveViewAF", "LiveViewAFAreaMode", "LiveViewAFMethod", "LiveViewAFMode", "LiveViewButtonOptions", "LiveViewExposureSimulation", "LiveViewFocusMode", "LiveViewMetering", "LiveViewMonitorOffTime", "LiveViewShooting", "LocalLocationName", "Location", "LocationInfoVersion", "LocationName", "LockMicrophoneButton", "LongExposureNoiseReduction", "LongExposureNRUsed", "LowLightAF", "LuminanceNoiseAmplitude", "LuminanceNoiseReduction", "LVShootingAreaDisplay", "M16CVersion", "Macro", "MacroLED", "MacroMode", "MagicFilter", "MagnifiedView", "MainDialExposureComp", "MakerNoteOffset", "MakerNoteType", "MakerNoteVersion", "ManometerPressure", "ManometerReading", "ManualAFPointSelectPattern", "ManualAFPointSelPattern", "ManualFlash", "ManualFlashOutput", "ManualFlashStrength", "ManualFocusDistance", "ManualFocusPointIllumination", "ManualFocusRingInAFMode", "ManualTv", "ManufactureDate", "MasterGain", "MatrixMetering", "MaxAperture", "MaxApertureAtMaxFocal", "MaxApertureAtMinFocal", "MaxContinuousRelease", "MaxFaces", "MaxFocalLength", "MCCData", "MCUVersion", "MeasuredEV", "MeasuredLV", "MeasuredRGGB", "MeasuredRGGBData", "MechanicalShutterCount", "MemoAudioQuality", "MemoryCardConfiguration", "MemoryCardNumber", "MenuButtonDisplayPosition", "MenuButtonReturn", "MenuMonitorOffTime", "MergedImages", "MetaVersion", "Metering", "MeteringOffScaleIndicator", "MeteringTime", "MeterMode", "MidRangeSharpness", "MinAperture", "MinFocalLength", "MinFocusDistance", "MiniatureFilter", "MiniatureFilterOrientation", "MiniatureFilterParameter", "MiniatureFilterPosition", "MinimumISO", "MinoltaDate", "MinoltaImageSize", "MinoltaModelID", "MinoltaQuality", "MinoltaTime", "MirrorLockup", "ModeDialPosition", "ModelingFlash", "ModelReleaseYear", "ModifiedColorTemp", "ModifiedDigitalGain", "ModifiedParamFlag", "ModifiedPictureStyle", "ModifiedSaturation", "ModifiedSensorBlueLevel", "ModifiedSensorRedLevel", "ModifiedSharpness", "ModifiedSharpnessFreq", "ModifiedToneCurve", "ModifiedWhiteBalance", "ModifiedWhiteBalanceBlue", "ModifiedWhiteBalanceRed", "MonitorBrightness", "MonitorDisplayOff", "MonitorOffTime", "MonochromeColor", "MonochromeFilterEffect", "MonochromeGrainEffect", "MonochromeProfileSettings", "MonochromeToning", "MonochromeVignetting", "MonthDayCreated", "MoonPhase", "MotionSensitivity", "MovieAELockButtonAssignment", "MovieAFAreaMode", "MovieAFTrackingSensitivity", "MovieFlickerReduction", "MovieFunc1Button", "MovieFunc2Button", "MovieFunc3Button", "MovieFunctionButton", "MovieFunctionButtonPlusDials", "MovieHighlightDisplayPattern", "MovieHighlightDisplayThreshold", "MovieISOAutoControlManualMode", "MovieISOAutoHiLimit", "MovieLensControlRing", "MovieMultiSelector", "MoviePreviewButton", "MoviePreviewButtonPlusDials", "MovieShutterButton", "MovieSubSelectorAssignment", "MovieSubSelectorAssignmentPlusDials", "MovieType", "MovieWhiteBalanceSameAsPhoto", "MultiControllerWhileMetering", "MultiExposure", "MultiExposureAutoGain", "MultiExposureControl", "MultiExposureMode", "MultiExposureOverlayMode", "MultiExposureShots", "MultiExposureVersion", "MultiFrameNoiseReduction", "MultiFrameNREffect", "MultiFunctionLock", "MultipleExposureMode", "MultipleExposureSet", "MultiSelector", "MultiSelectorLiveView", "MultiSelectorPlaybackMode", "MultiSelectorShootMode", "MyColorMode", "NDFilter", "NEFBitDepth", "NEFCompression", "NEFLinearizationTable", "NeutralDensityFilter", "NikonCaptureVersion", "NikonImageSize", "NikonMeteringMode", "NoiseFilter", "NoiseReduction", "NoiseReductionStrength", "NoMemoryCard", "NominalMaxAperture", "NominalMinAperture", "NormalWhiteLevel", "NumberOfFocusPoints", "NumberOffsets", "NumCAFPoints", "NumFaceElements", "NumFacePositions", "ObjectDistance", "OISMode", "OKButton", "OlympusImageHeight", "OlympusImageWidth", "OneTouchWB", "OpticalVR", "OpticalZoom", "OpticalZoomCode", "OpticalZoomMode", "OpticalZoomOn", "OrderNumber", "OrientationLinkedAF", "OrientationLinkedAFPoint", "OriginalDirectory", "OriginalFileName", "OriginalImageHeight", "OriginalImageWidth", "OtherInfo", "OutputLUT", "OwnerName", "PaintingFilter", "PanasonicDateTime", "PanasonicExifVersion", "PanasonicImageHeight", "PanasonicImageWidth", "PanoramaAngle", "PanoramaCropBottom", "PanoramaCropLeft", "PanoramaCropRight", "PanoramaCropTop", "PanoramaDirection", "PanoramaFrameHeight", "PanoramaFrameWidth", "PanoramaFullHeight", "PanoramaFullWidth", "PanoramaMode", "PanoramaSize3D", "PanoramaSourceHeight", "PanoramaSourceWidth", "PentaxImageSize", "PentaxModelID", "PentaxModelType", "PentaxVersion", "PerChannelBlackLevel", "PeripheralIlluminationCorr", "PeripheralLighting", "PeripheralLightingSetting", "PeripheralLightingValue", "PhotoEffect", "PhotoIdentifier", "PhotoInfoPlayback", "PhotosAppFeatureFlags", "PhotoShootingMenuBank", "PhotoShootingMenuBankImageArea", "PhotoStyle", "PictureControlAdjust", "PictureControlBase", "PictureControlName", "PictureControlQuickAdjust", "PictureControlVersion", "PictureEffect", "PictureFinish", "PictureMode", "PictureModeBWFilter", "PictureModeContrast", "PictureModeEffect", "PictureModeSaturation", "PictureModeSharpness", "PictureModeTone", "PictureProfile", "PictureStyle", "PictureStylePC", "PictureStyleUserDef", "Pitch", "PitchAngle", "PixelAspectRatio", "PixelShiftInfo", "PixelShiftResolution", "PixelShiftShooting", "PlaybackMenusTime", "PlaybackMonitorOffTime", "PlaybackZoom", "PlayDisplay", "POILevel", "PopupFlash", "PortraitImpressionBalance", "PortraitRefiner", "PostFocusMerging", "PostReleaseBurstLength", "PowerSource", "PowerUpTime", "PreAF", "PreCaptureFrames", "PreReleaseBurstLength", "PresetWhiteBalance", "PreviewButton", "PreviewButtonPlusDials", "PreviewImageBorders", "PreviewImageHeight", "PreviewImageLength", "PreviewImageSize", "PreviewImageStart", "PreviewImageValid", "PreviewImageWidth", "PreviewQuality", "PrimaryAFPoint", "PrimarySlot", "PrioritySetupShutterRelease", "ProductionCode", "ProgramISO", "ProgramLine", "ProgramShift", "Quality", "QuickControlDialInMeter", "QuickShot", "RangeFinder", "RawAndJpgRecording", "RawDataByteOrder", "RawDataCFAPattern", "RawDataLength", "RawDevArtFilter", "RawDevAutoGradation", "RawDevColorSpace", "RawDevContrastValue", "RawDevEditStatus", "RawDevelopmentProcess", "RawDevEngine", "RawDevExposureBiasValue", "RawDevGradation", "RawDevGrayPoint", "RawDevMemoryColorEmphasis", "RawDevNoiseReduction", "RawDevPictureMode", "RawDevPMContrast", "RawDevPMNoiseFilter", "RawDevPMPictureTone", "RawDevPMSaturation", "RawDevPMSharpness", "RawDevSaturationEmphasis", "RawDevSettings", "RawDevSharpnessValue", "RawDevVersion", "RawDevWBFineAdjustment", "RawDevWhiteBalance", "RawDevWhiteBalanceValue", "RAWFileType", "RawImageCenter", "RawImageHeight", "RawImageWidth", "RawJpgQuality", "RawJpgSize", "RawMeasuredRGGB", "RearDisplay", "RecordDisplay", "RecordID", "RecordingFormat", "RecordingMode", "RecordMode", "RecordShutterRelease", "RedEyeRemoval", "RedGain", "ReleaseButtonToUseDial", "ReleaseMode", "RemoteFuncButton", "RemoteOnDuration", "RepeatingFlashCount", "RepeatingFlashOutput", "RepeatingFlashOutputExternal", "RepeatingFlashRate", "Resaved", "ResolutionMode", "RestrictDriveModes", "RetouchHistory", "RetouchInfoVersion", "RetouchNEFProcessing", "RetractLensOnPowerOff", "ReverseExposureCompDial", "ReverseFocusRing", "ReverseIndicators", "ReverseShutterSpeedAperture", "RFLensMFFocusRingSensitivity", "RFLensType", "RicohDate", "RicohImageHeight", "RicohImageWidth", "RicohMake", "RicohModel", "Roll", "RollAngle", "ROMOperationMode", "RunTimeEpoch", "RunTimeFlags", "RunTimeScale", "RunTimeValue", "SafetyShift", "SafetyShiftInAvOrTv", "SameExposureForNewAperture", "SamsungModelID", "SanyoQuality", "SanyoThumbnail", "SaturationAdj", "SaturationAuto", "SaturationLandscape", "SaturationNeutral", "SaturationPortrait", "SaturationSetting", "SaturationStandard", "SaveFocus", "ScanImageEnhancer", "SceneAssist", "SceneDetect", "SceneMode", "SceneModeUsed", "SceneRecognition", "SceneSelect", "ScreenTips", "SecondarySlotFunction", "SelectableAFPoint", "SelectAFAreaSelectionMode", "SelectAFAreaSelectMode", "SelfTimer", "SelfTimerInterval", "SelfTimerShotCount", "SelfTimerShotInterval", "SelfTimerTime", "SemanticStyle", "SemanticStylePreset", "SemanticStyleRenderingVer", "SensitivityAdjust", "SensitivitySteps", "Sensor", "SensorBitDepth", "SensorBlueLevel", "SensorBottomBorder", "SensorCalibration", "SensorCleaning", "SensorFullHeight", "SensorFullWidth", "SensorHeight", "SensorID", "SensorLeftBorder", "SensorPixelSize", "SensorRedLevel", "SensorRightBorder", "SensorSize", "SensorTemperature", "SensorTopBorder", "SensorType", "SensorWidth", "Sequence", "SequenceFileNumber", "SequenceImageNumber", "SequenceLength", "SequenceNumber", "SequenceShotInterval", "SequentialShot", "SerialNumber", "SerialNumberFormat", "SetButtonCrossKeysFunc", "SetButtonWhenShooting", "SetFunctionWhenShooting", "ShadingCompensation", "Shadow", "ShadowCorrection", "Shadows", "ShadowTone", "ShakeReduction", "Sharpening", "SharpnessAuto", "SharpnessFactor", "SharpnessFaithful", "SharpnessFreqTable", "SharpnessFrequency", "SharpnessLandscape", "SharpnessNeutral", "SharpnessPortrait", "SharpnessRange", "SharpnessSetting", "SharpnessStandard", "SharpnessTable", "ShootingInfoDisplay", "ShootingInfoMonitorOffTime", "ShootingModeSetting", "ShortOwnerName", "ShortReleaseTimeLag", "ShotInfoVersion", "ShotNumberSincePowerUp", "ShotsPerInterval", "Shutter", "ShutterAELButton", "ShutterButtonAFOnButton", "ShutterCount", "ShutterCount2", "ShutterCount3", "ShutterCurtainSync", "ShutterMode", "ShutterReleaseMethod", "ShutterReleaseNoCFCard", "ShutterReleaseTiming", "ShutterReleaseWithoutLens", "ShutterSpeedLock", "ShutterSpeedRange", "ShutterSpeedSetting", "ShutterType", "SignalToNoiseRatio", "SilentPhotography", "SingleFrame", "SingleFrameBracketing", "SkinToneCorrection", "SlaveFlashMeteringSegments", "SlowShutter", "SlowSync", "SmartAlbumColor", "SmileShutter", "SmileShutterMode", "SoftFocusFilter", "SoftSkinEffect", "SonyDateTime", "SonyDateTime2", "SonyExposureTime", "SonyFNumber", "SonyImageHeight", "SonyImageHeightMax", "SonyImageSize", "SonyImageWidth", "SonyImageWidthMax", "SonyISO", "SonyMaxAperture", "SonyMaxApertureValue", "SonyMinAperture", "SonyModelID", "SonyQuality", "SonyTimeMinSec", "SourceDirectoryIndex", "SourceFileIndex", "SpecialEffectLevel", "SpecialEffectMode", "SpecialEffectSetting", "SpecialMode", "SpecularWhiteLevel", "SpeedX", "SpeedY", "SpeedZ", "SpotFocusPointX", "SpotFocusPointY", "SpotMeteringMode", "SpotMeterLinkToAFPoint", "SRActive", "SRAWQuality", "SRFocalLength", "SRHalfPressTime", "SRResult", "StackedImage", "StandbyMonitorOffTime", "StandbyTimer", "StartMovieShooting", "StopsAboveBaseISO", "StoreByOrientation", "SubDialFrameAdvance", "SubjectDetection", "SubjectDetectionAreaMF", "SubjectMotion", "SubjectProgram", "SubjectToDetect", "SubSelector", "SubSelectorAssignment", "SubSelectorCenter", "SubSelectorPlusDials", "SuperimposedDisplay", "SuperMacro", "SvISOSetting", "SweepPanoramaDirection", "SweepPanoramaFieldOfView", "SweepPanoramaSize", "SwitchToRegisteredAFPoint", "SyncReleaseMode", "TargetAperture", "TargetCompressionRatio", "TargetDistanceSetting", "TargetExposureTime", "TargetImageType", "Teleconverter", "TextEncoding", "TextStamp", "ThumbnailFileName", "ThumbnailHeight", "ThumbnailImageValidArea", "ThumbnailWidth", "TiffMeteringImage", "TiffMeteringImageHeight", "TiffMeteringImageWidth", "Time", "TimeLapseShotNumber", "TimerFunctionButton", "TimerLength", "TimerRecording", "TimeSincePowerOn", "TimeStamp", "TimeZone", "TimeZoneCity", "TimeZoneCode", "TimeZoneInfo", "ToneComp", "ToneCurve", "ToneCurveMatching", "ToneCurveTable", "ToneLevel", "ToningEffect", "ToningEffectAuto", "ToningSaturation", "TotalZoom", "TouchAE", "ToyCameraFilter", "Transform", "TrashButtonFunction", "TravelDay", "TriggerMode", "TvExposureTimeSetting", "UniqueID", "UnknownNumber", "UnsharpMaskFineness", "UnsharpMaskThreshold", "UsableMeteringModes", "UsableShootingModes", "USBPowerDelivery", "UserLabel", "UserProfile", "USMLensElectronicMF", "ValidBits", "VariableLowPassFilter", "VariProgram", "VerticalAFOnButton", "VerticalFuncButton", "VerticalFuncButtonPlusDials", "VerticalMovieAFOnButton", "VerticalMovieFuncButton", "VerticalMultiSelector", "VFDisplayIllumination", "VibrationReduction", "VideoBurstMode", "VideoBurstResolution", "VideoPreburst", "ViewfinderDisplay", "ViewfinderWarning", "ViewfinderWarnings", "ViewInfoDuringExposure", "ViewingMode", "VignetteControl", "Vignetting", "VignettingCorrection", "VignettingCorrParams", "VignettingCorrVersion", "VoiceMemo", "VRDOffset", "VRInfoVersion", "VRMode", "VRType", "WatercolorFilter", "WBBlueLevel", "WBBracketingSteps", "WBBracketMode", "WBBracketShotNumber", "WBBracketValueAB", "WBBracketValueGM", "WBButtonPlaybackMode", "WBGreenLevel", "WBMediaImageSizeSetting", "WBMode", "WBRedLevel", "WBShiftAB", "WBShiftCreativeControl", "WBShiftGM", "WBShiftIntelligentAuto", "WhiteBalanceAutoAdjustment", "WhiteBalanceBias", "WhiteBalanceBlue", "WhiteBalanceBracket", "WhiteBalanceBracketing", "WhiteBalanceFineTune", "WhiteBalanceMatching", "WhiteBalanceMode", "WhiteBalanceRed", "WhiteBalanceSet", "WhiteBalanceSetting", "WhiteBalanceSetup", "WhiteBalanceTable", "WhiteBalanceTemperature", "WhiteBoard", "WideAdapter", "WideFocusZone", "WideRange", "WorldTimeLocation", "X3FillLight", "Xidiri", "Yaw", "YawAngle", "YearCreated", "ZoneMatching", "ZoneMatchingMode", "ZoneMatchingOn", "ZoneMatchingValue", "ZoomedPreviewImage", "ZoomedPreviewLength", "ZoomedPreviewSize", "ZoomedPreviewStart", "ZoomSourceWidth", "ZoomStepCount", "ZoomTargetWidth");
exports.XMPTagsNames = (0, StrEnum_1.strEnum)("About", "AbsoluteAltitude", "Album", "AlreadyApplied", "ApproximateFocusDistance", "AsrClimaxDuration", "AsrClimaxScene", "AsrIsMacroRange", "AsrSceneCondition", "AsrSceneMode", "AutoLateralCA", "BandName", "BlueHue", "BlueSaturation", "BurstID", "BurstPrimary", "CameraBurstID", "CameraFacing", "CameraModelID", "CameraProfile", "CameraProfileDigest", "Cameras", "CameraUnit", "CamReverse", "CaptureMode", "CaptureSoftware", "CatalogSets", "CellGlobalID", "CellR", "CellTowerID", "CentralTemperature", "CentralWavelength", "Changes", "CircularGradientBasedCorrections", "ColorClass", "ColorLabel", "Colorlabels", "ColorNoiseReduction", "ColorNoiseReductionDetail", "ColorNoiseReductionSmoothness", "Comment", "Container", "ContainerDirectory", "ConvertToGrayscale", "Country", "CountryCode", "CreationTime", "Creator", "CreatorAppID", "CreatorContactInfo", "CreatorOpenWithUIOptions", "Creatortool", "CreatorTool", "CropAngle", "CropBottom", "CropConstrainToWarp", "CropLeft", "CroppedAreaImageHeightPixels", "CroppedAreaImageWidthPixels", "CroppedAreaLeftPixels", "CroppedAreaTopPixels", "CropRight", "CropTop", "DateAcquired", "DateCreated", "DateTime", "DateTimeDigitized", "DateUTC", "DefringeGreenAmount", "DefringeGreenHueHi", "DefringeGreenHueLo", "DefringePurpleAmount", "DefringePurpleHueHi", "DefringePurpleHueLo", "Dehaze", "DerivedFrom", "Description", "DisableAutoCreation", "DocumentID", "Face", "FaceNum", "FaceSelectedIndex", "Far", "Firmware", "FlashCompensation", "FlashManufacturer", "FlashPixVersion", "FlightPitchDegree", "FlightRollDegree", "FlightYawDegree", "FocusAreaHeight", "FocusAreaNum", "FocusAreaWidth", "FocusIsLensMoving", "FocusPosX", "FocusPosY", "FocusState", "Format", "FullPanoHeightPixels", "FullPanoWidthPixels", "GimbalPitchDegree", "GimbalReverse", "GimbalRollDegree", "GimbalYawDegree", "GrainAmount", "GreenHue", "GreenSaturation", "HasCrop", "HasExtendedXMP", "HasSettings", "HdrPlusMakernote", "HDRPMakerNote", "HierarchicalSubject", "History", "HueAdjustmentAqua", "HueAdjustmentBlue", "HueAdjustmentGreen", "HueAdjustmentMagenta", "HueAdjustmentOrange", "HueAdjustmentPurple", "HueAdjustmentRed", "HueAdjustmentYellow", "ICCProfileName", "ImageLength", "ImageNumber", "InitialViewHeadingDegrees", "InitialViewPitchDegrees", "InitialViewRollDegrees", "InstanceID", "InteroperabilityIndex", "InteroperabilityVersion", "IsBokehActive", "IsHDRActive", "IsNightModeActive", "Label", "LastKeywordXMP", "LegacyIPTCDigest", "LensFacing", "LensManualDistortionAmount", "LensManufacturer", "LensProfileEnable", "LensProfileName", "LensProfileSetup", "LocationAreaCode", "Look", "LuminanceAdjustmentAqua", "LuminanceAdjustmentBlue", "LuminanceAdjustmentGreen", "LuminanceAdjustmentMagenta", "LuminanceAdjustmentOrange", "LuminanceAdjustmentPurple", "LuminanceAdjustmentRed", "LuminanceAdjustmentYellow", "LuminanceSmoothing", "MakerNote", "Marked", "Mask", "MetadataDate", "MicroVideo", "MicroVideoOffset", "MicroVideoPresentationTimestampUs", "MicroVideoVersion", "Mime", "MobileCountryCode", "MobileNetworkCode", "ModificationDate", "MotionPhoto", "MotionPhotoPresentationTimestampUs", "MotionPhotoVersion", "NativeDigest", "Near", "Notes", "ObjectAreaHeight", "ObjectAreaWidth", "ObjectNum", "ObjectPosX", "ObjectPosY", "OriginalCreateDateTime", "OriginalDocumentID", "OverrideLookVignette", "ParametricDarks", "ParametricHighlights", "ParametricHighlightSplit", "ParametricLights", "ParametricMidtoneSplit", "ParametricShadows", "ParametricShadowSplit", "PersonInImage", "PerspectiveAspect", "PerspectiveHorizontal", "PerspectiveRotate", "PerspectiveScale", "PerspectiveUpright", "PerspectiveVertical", "PerspectiveX", "PerspectiveY", "PhotographicSensitivity", "PickLabel", "PipelineVersion", "PMVersion", "PortraitVersion", "PoseHeadingDegrees", "PosePitchDegrees", "PoseRollDegrees", "PostCropVignetteAmount", "PreservedFileName", "ProcessVersion", "Profiles", "ProgramMode", "ProjectionType", "Rating", "RatingPercent", "RawFileName", "RedHue", "RedSaturation", "RegionInfo", "RegionInfoMP", "RegistryID", "RelativeAltitude", "Rights", "SaturationAdjustmentAqua", "SaturationAdjustmentBlue", "SaturationAdjustmentGreen", "SaturationAdjustmentMagenta", "SaturationAdjustmentOrange", "SaturationAdjustmentPurple", "SaturationAdjustmentRed", "SaturationAdjustmentYellow", "Scene", "SceneDetectResultConfidences", "SceneDetectResultIds", "SelfData", "ShadowTint", "SharpenDetail", "SharpenEdgeMasking", "SharpenRadius", "SourcePhotosCount", "SpecialTypeID", "SplitToningBalance", "SplitToningHighlightHue", "SplitToningHighlightSaturation", "SplitToningShadowHue", "SplitToningShadowSaturation", "State", "StitchingSoftware", "StreamType", "Subject", "SubsecTime", "Tag", "Tagged", "TagsList", "Tint", "Title", "TlinearGain", "ToneCurveBlue", "ToneCurveGreen", "ToneCurveName", "ToneCurvePV2012Blue", "ToneCurvePV2012Green", "ToneCurvePV2012Red", "ToneCurveRed", "ToneMapStrength", "UprightCenterMode", "UprightCenterNormX", "UprightCenterNormY", "UprightFocalLength35mm", "UprightFocalMode", "UprightFourSegmentsCount", "UprightPreview", "UprightTransformCount", "UprightVersion", "UsePanoramaViewer", "Versions", "Vibrance", "VignetteAmount", "WavelengthFWHM", "XMPMeta", "XMPToolkit");
/**
 * All tag names combined from all interfaces
 */
exports.TagNames = (0, StrEnum_1.strEnum)(...exports.ExifToolTagsNames.values, ...exports.FileTagsNames.values, ...exports.APPTagsNames.values, ...exports.CompositeTagsNames.values, ...exports.FlashPixTagsNames.values, ...exports.JSONTagsNames.values, ...exports.MPFTagsNames.values, ...exports.EXIFTagsNames.values, ...exports.MetaTagsNames.values, ...exports.PanasonicRawTagsNames.values, ...exports.PhotoshopTagsNames.values, ...exports.PrintIMTagsNames.values, ...exports.QuickTimeTagsNames.values, ...exports.RAFTagsNames.values, ...exports.RIFFTagsNames.values, ...exports.IPTCTagsNames.values, ...exports.JFIFTagsNames.values, ...exports.MakerNotesTagsNames.values, ...exports.XMPTagsNames.values, ...ExifToolVendoredTags_1.ExifToolVendoredTagNames.values, ...GeolocationTags_1.GeolocationTagNames.values, ...ImageDataHashTag_1.ImageDataHashTagNames.values, ...ICCProfileTags_1.ICCProfileTagNames.values, ...IPTCApplicationRecordTags_1.IPTCApplicationRecordTagNames.values, ...MWGTags_1.MWGCollectionsTagNames.values, ...MWGTags_1.MWGKeywordTagNames.values);
//# sourceMappingURL=Tags.js.map